<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::pair_remover&lt; domain, range &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="classdlib_1_1pair__remover-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::pair_remover&lt; domain, range &gt; Class Template Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">
<div class="dynheader">
Inheritance diagram for dlib::pair_remover&lt; domain, range &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classdlib_1_1pair__remover.png" usemap="#dlib::pair_5Fremover_3C_20domain_2C_20range_20_3E_map" alt=""/>
  <map id="dlib::pair_5Fremover_3C_20domain_2C_20range_20_3E_map" name="dlib::pair_5Fremover_3C_20domain_2C_20range_20_3E_map">
<area href="classdlib_1_1asc__pair__remover.html" alt="dlib::asc_pair_remover&lt; domain, range, bst_base::compare_type &gt;" shape="rect" coords="0,56,469,80"/>
<area href="classdlib_1_1asc__pair__remover.html" alt="dlib::asc_pair_remover&lt; domain, range, compare &gt;" shape="rect" coords="718,56,1187,80"/>
<area href="classdlib_1_1hash__map__kernel__1.html" alt="dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt;" shape="rect" coords="1197,56,1666,80"/>
<area href="classdlib_1_1hash__table__kernel__1.html" alt="dlib::hash_table_kernel_1&lt; domain, range, mem_manager, compare &gt;" shape="rect" coords="1676,56,2145,80"/>
<area href="classdlib_1_1hash__table__kernel__2.html" alt="dlib::hash_table_kernel_2&lt; domain, range, bst_base, mem_manager, compare &gt;" shape="rect" coords="2155,56,2624,80"/>
<area href="classdlib_1_1map__kernel__1.html" alt="dlib::map_kernel_1&lt; domain, range, bst_base, mem_manager &gt;" shape="rect" coords="0,112,469,136"/>
<area href="classdlib_1_1binary__search__tree__kernel__1.html" alt="dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt;" shape="rect" coords="479,112,948,136"/>
<area href="classdlib_1_1binary__search__tree__kernel__2.html" alt="dlib::binary_search_tree_kernel_2&lt; domain, range, mem_manager, compare &gt;" shape="rect" coords="958,112,1427,136"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:ae77d4c0fb6e38060543ef5323dfeeccc"><td class="memItemLeft" align="right" valign="top">typedef domain&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#ae77d4c0fb6e38060543ef5323dfeeccc">domain_type</a></td></tr>
<tr class="separator:ae77d4c0fb6e38060543ef5323dfeeccc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7250053c066db818a5f0c0a886f25a20"><td class="memItemLeft" align="right" valign="top"><a id="a7250053c066db818a5f0c0a886f25a20"></a>
typedef range&#160;</td><td class="memItemRight" valign="bottom"><b>range_type</b></td></tr>
<tr class="separator:a7250053c066db818a5f0c0a886f25a20"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a07c56b5db740660bed160d3ed3e3770f"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#a07c56b5db740660bed160d3ed3e3770f">remove_any</a> (domain &amp;d, range &amp;r)=0</td></tr>
<tr class="separator:a07c56b5db740660bed160d3ed3e3770f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30eb487cc84f46066fbc446c46beb63b"><td class="memItemLeft" align="right" valign="top">virtual unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#a30eb487cc84f46066fbc446c46beb63b">size</a> () const =0</td></tr>
<tr class="separator:a30eb487cc84f46066fbc446c46beb63b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:aead61aff1af3e012c691953da8020750"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classdlib_1_1pair__remover.html#aead61aff1af3e012c691953da8020750">operator=</a> (const <a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a> &amp;)</td></tr>
<tr class="separator:aead61aff1af3e012c691953da8020750"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Typedef Documentation</h2>
<a id="ae77d4c0fb6e38060543ef5323dfeeccc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae77d4c0fb6e38060543ef5323dfeeccc">&#9670;&nbsp;</a></span>domain_type</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">typedef domain <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover</a>&lt; domain, range &gt;::<a class="el" href="classdlib_1_1pair__remover.html#ae77d4c0fb6e38060543ef5323dfeeccc">domain_type</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">REQUIREMENTS ON domain
    domain is swappable by a global swap() and                
    domain must have a default constructor

REQUIREMENTS ON range
    range is swappable by a global swap() and
    range must have a default constructor

POINTERS AND REFERENCES TO INTERNAL DATA
    The size() function does not invalidate pointers or 
    references to internal data.  All other functions have no such 
    guarantee.

WHAT THIS OBJECT REPRESENTS
    This object represents some generalized interface for removing
    pairs from container classes which enforce some kind of pairing on
    the elements that they contain.  
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aead61aff1af3e012c691953da8020750"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aead61aff1af3e012c691953da8020750">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a>&amp; <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover</a>&lt; domain, range &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classdlib_1_1pair__remover.html">pair_remover</a>&lt; domain, range &gt; &amp;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns the number of elements in *this 
</pre><p> ! </p>

</div>
</div>
<a id="a07c56b5db740660bed160d3ed3e3770f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07c56b5db740660bed160d3ed3e3770f">&#9670;&nbsp;</a></span>remove_any()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover</a>&lt; domain, range &gt;::remove_any </td>
          <td>(</td>
          <td class="paramtype">domain &amp;&#160;</td>
          <td class="paramname"><em>d</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">range &amp;&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - all resources associated with *this have been released.
</pre><p> ! </p>

<p>Implemented in <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#a97284253c0e7b4c9e2b4a715e6497f74">dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1binary__search__tree__kernel__2.html#a72d6c04078b3c281249eba64133dbed2">dlib::binary_search_tree_kernel_2&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__table__kernel__1.html#abb606d29a36fbd9dbad4e3739f81f6a5">dlib::hash_table_kernel_1&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__table__kernel__2.html#aee675fe77ea4b884d0e2dca198052c5a">dlib::hash_table_kernel_2&lt; domain, range, bst_base, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__map__kernel__1.html#afd3f074a7737c9bb060d0c54116673e8">dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt;</a>, and <a class="el" href="classdlib_1_1map__kernel__1.html#aa5a8f52c9f9b125db9aec11ad01b324f">dlib::map_kernel_1&lt; domain, range, bst_base, mem_manager &gt;</a>.</p>

</div>
</div>
<a id="a30eb487cc84f46066fbc446c46beb63b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a30eb487cc84f46066fbc446c46beb63b">&#9670;&nbsp;</a></span>size()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename domain , typename range &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned long <a class="el" href="classdlib_1_1pair__remover.html">dlib::pair_remover</a>&lt; domain, range &gt;::size </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires                     
    - &amp;d != &amp;r (i.e. d and r cannot be the same variable) 
    - size() != 0
ensures
    - #size() == size() - 1
    - removes an element from the domain of *this and swaps it
      into d.  
    - removes the element in *this's range that is associated 
      with #d and swaps it into r.
    - if (*this implements the enumerable interface) then
        - #at_start() == true
</pre><p> ! </p>

<p>Implemented in <a class="el" href="classdlib_1_1binary__search__tree__kernel__2.html#ae338c37a005c6b97a4bbb4776ae42dd5">dlib::binary_search_tree_kernel_2&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1binary__search__tree__kernel__1.html#ab1ea985c164591279a5d82b822dfdc3f">dlib::binary_search_tree_kernel_1&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__table__kernel__1.html#ae1add76c0753784587cbad65a38bed9a">dlib::hash_table_kernel_1&lt; domain, range, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__table__kernel__2.html#ac9725c4160a61c758ad7c56287143c40">dlib::hash_table_kernel_2&lt; domain, range, bst_base, mem_manager, compare &gt;</a>, <a class="el" href="classdlib_1_1hash__map__kernel__1.html#a29696c9c313362a244392c4ce80d948c">dlib::hash_map_kernel_1&lt; domain, range, expnum, hash_table, mem_manager &gt;</a>, and <a class="el" href="classdlib_1_1map__kernel__1.html#a947c2e84be3c2ee32734fd41daf93cae">dlib::map_kernel_1&lt; domain, range, bst_base, mem_manager &gt;</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="remover_8h_source.html">remover.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
